
/*******************************************************************************
*
* File check1.c
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Generation of permutations.
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "utils.h"
#include "permutations.h"


static void check_binomial(int nmx)
{
   int n,m;
   long b,f1,f2,f3;

   printf("n!  = %ld",factorial(0));

   for (n=1;n<=nmx;n++)
      printf(",%ld",factorial(n));

   printf("\n");

   printf("n!! = %ld",factorial2(0));

   for (n=1;n<=nmx;n++)
      printf(",%ld",factorial2(n));

   printf("\n\n");

   for (n=0;n<=nmx;n++)
   {
      for (m=0;m<=n;m++)
      {
         b=binomial(n,m);
         f1=factorial(n);
         f2=factorial(m);
         f3=factorial(n-m);

         if (b!=(f1/(f2*f3)))
            error(1,1,"check_binomial [check1.c]",
                  "Incorrect binomial coefficient");
      }
   }
}


int main(void)
{
   int m,i,j,k,nt;
   int *n,*p;
   long np,npm;

   printf("\n");
   printf("Generation of permutations\n");
   printf("--------------------------\n\n");

   check_binomial(12);

   while(1)
   {
      printf("Specify number of subsequences: ");
      (void)scanf("%d",&m);

      n=malloc(m*sizeof(*n));
      error(n==NULL,1,"main [check1.c]","Unable to allocate lengths array");

      printf("Specify lengths of subsequences: ");

      for (i=0;i<m;i++)
         (void)scanf("%d",n+i);

      printf("\n");
      printf("m = %d, n = %d",m,n[0]);
      nt=n[0];

      for (i=1;i<m;i++)
      {
         printf(",%d",n[i]);
         nt+=n[i];
      }

      printf("\n\n");
      printf("Permutations:\n");

      np=0L;
      npm=init_perm(m,n);
      printf("Total number of permutations = %ld\n",npm);

      p=malloc(nt*sizeof(*p));
      error(p==NULL,1,"main [check1.c]","Unable to allocate sequence array");

      while (np<npm)
      {
         np=next_perm(p);
         printf("np = %3ld, ",np);
         k=0;

         for (i=0;i<m;i++)
         {
            if (i==0)
               printf("(");
            else
               printf(",(");

            for (j=0;j<n[i];j++)
            {
               if (j==0)
                  printf("%d",p[k]);
               else
                  printf(",%d",p[k]);

               k+=1;
            }

            printf(")");
         }

         printf("\n");
      }

      printf("\n");
      printf("Wrapping around:\n");
      np=0L;

      while (np<(npm/2))
      {
         np=next_perm(p);
         printf("np = %3ld, ",np);
         k=0;

         for (i=0;i<m;i++)
         {
            if (i==0)
               printf("(");
            else
               printf(",(");

            for (j=0;j<n[i];j++)
            {
               if (j==0)
                  printf("%d",p[k]);
               else
                  printf(",%d",p[k]);

               k+=1;
            }

            printf(")");
         }

         printf("\n");
      }

      printf("...\n\n");
      stop_perm();
   }

   exit(0);
}
