
/*******************************************************************************
*
* File check3.c
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Generation of multi-index vectors.
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "utils.h"
#include "permutations.h"


int main(void)
{
   int m,i,j,k,nt,cid;
   int *n,(*r)[2],*iv;
   long ni,nim;

   printf("\n");
   printf("Generation of multi-index vectors\n");
   printf("---------------------------------\n\n");

   while(1)
   {
      printf("Specify number of index groups: ");
      (void)scanf("%d",&m);

      n=malloc(m*sizeof(*n));
      r=malloc(m*sizeof(*r));
      error((n==NULL)||(r==NULL),1,"main [check3.c]",
            "Unable to allocate auxiliary arrays");

      printf("Specify size and index range of each group [n r[0] r[1]]: ");

      for (i=0;i<m;i++)
         (void)scanf("%d %d %d",n+i,r[i],r[i]+1);

      printf("\n");
      printf("m = %d, (n,r[0],r[1]), ... = (%d,%d,%d)",m,n[0],r[0][0],r[0][1]);
      nt=n[0];

      for (i=1;i<m;i++)
      {
         printf(",(%d,%d,%d)",n[i],r[i][0],r[i][1]);
         nt+=n[i];
      }

      printf("\n\n");
      printf("Index vectors:\n");

      ni=0L;
      nim=init_mindex(m,n,r,&cid);
      printf("Total number of index vectors = %ld, ",nim);
      printf("id = %d\n",cid);

      iv=malloc(nt*sizeof(*iv));
      error(iv==NULL,1,"main [check3.c]","Unable to allocate index vector");

      while (ni<nim)
      {
         ni=next_mindex(cid,iv);
         printf("ni = %3ld, ",ni);
         k=0;

         for (i=0;i<m;i++)
         {
            if (i==0)
               printf("(");
            else
               printf(",(");

            for (j=0;j<n[i];j++)
            {
               if (j==0)
                  printf("%d",iv[k]);
               else
                  printf(",%d",iv[k]);

               k+=1;
            }

            printf(")");
         }

         printf("\n");
      }

      printf("\n");
      printf("Wrapping around:\n");
      ni=0L;

      while (ni<(nim/2L))
      {
         ni=next_mindex(cid,iv);
         printf("ni = %3ld, ",ni);
         k=0;

         for (i=0;i<m;i++)
         {
            if (i==0)
               printf("(");
            else
               printf(",(");

            for (j=0;j<n[i];j++)
            {
               if (j==0)
                  printf("%d",iv[k]);
               else
                  printf(",%d",iv[k]);

               k+=1;
            }

            printf(")");
         }

         printf("\n");
      }

      printf("...\n\n");

      if (cid==1)
         stop_mindex(0);
   }

   exit(0);
}
