
/*******************************************************************************
*
* File permutations.h
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef PERMUTATIONS_H
#define PERMUTATIONS_H

/* BINOMIAL_C */
extern long binomial(int n,int m);
extern long factorial(int n);
extern long factorial2(int n);

/* LNLIST_C */
extern long init_lnlist(int m,int *nv,int *nl,int **v,int **ne);
extern long next_lnlist(int (*p)[2],long *nc);
extern void stop_lnlist(void);

/* MINDEX_C */
extern long init_mindex(int m,int *n,int (*r)[2],int *cid);
extern long next_mindex(int cid,int *i);
extern void stop_mindex(int cid);

/* PARTITION_C */
extern long init_partition(int n,int s);
extern long next_partition(int *i);
extern void stop_partition(void);

/* PERMGEN_C */
extern long init_perm(int m,int *n);
extern long next_perm(int *p);
extern void stop_perm(void);

/* WICKGEN_C */
extern long init_wick(int m,int nb,int *n,int **a);
extern long next_wick(int (*p)[2]);
extern void stop_wick(void);

#endif
